Basic Waterfall in JavaScript

Using ApexCharts with JavaScript

This Basic Waterfall example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [
    {
      name: 'Operating income',
      data: [
        {
          x: 'Net revenue',
          y: 8786000,
        },
        {
          x: 'Cost of sales',
          y: -2786000,
        },
        {
          x: 'Gross profit',
          isSubtotal: true,
        },
        {
          x: 'Operating expenses',
          y: -1786000,
        },
        {
          x: 'Amortisation',
          y: -453000,
        },
        {
          x: 'Income from equity',
          y: 1465000,
        },
        {
          x: 'Operating income',
          isTotal: true,
        },
      ],
    },
  ],
  chart: {
    type: 'waterfall',
    height: 380,
  },
  title: {
    text: 'From revenue to operating income',
    align: 'left',
  },
  subtitle: {
    text: 'FY 2025, in thousands of USD',
    align: 'left',
  },
  yaxis: {
    labels: {
      formatter: function (val) {
        return (val / 1000).toFixed(0) + 'k'
      },
    },
  },
  dataLabels: {
    formatter: function (val) {
      return (val / 1000).toFixed(0) + 'k'
    },
  },
  tooltip: {
    y: {
      formatter: function (val) {
        return (val > 0 ? '+' : '') + val.toLocaleString('en-US')
      },
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Basic Waterfall in React

Using ApexCharts with React

This Basic Waterfall example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Operating income',
        data: [
          {
            x: 'Net revenue',
            y: 8786000,
          },
          {
            x: 'Cost of sales',
            y: -2786000,
          },
          {
            x: 'Gross profit',
            isSubtotal: true,
          },
          {
            x: 'Operating expenses',
            y: -1786000,
          },
          {
            x: 'Amortisation',
            y: -453000,
          },
          {
            x: 'Income from equity',
            y: 1465000,
          },
          {
            x: 'Operating income',
            isTotal: true,
          },
        ],
      },
    ],
    options: {
      chart: {
        type: 'waterfall',
        height: 380,
      },
      title: {
        text: 'From revenue to operating income',
        align: 'left',
      },
      subtitle: {
        text: 'FY 2025, in thousands of USD',
        align: 'left',
      },
      yaxis: {
        labels: {
          formatter: function (val) {
            return (val / 1000).toFixed(0) + 'k'
          },
        },
      },
      dataLabels: {
        formatter: function (val) {
          return (val / 1000).toFixed(0) + 'k'
        },
      },
      tooltip: {
        y: {
          formatter: function (val) {
            return (val > 0 ? '+' : '') + val.toLocaleString('en-US')
          },
        },
      },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="waterfall"
          height={380}
        />
      </div>
    </div>
  )
}

export default ApexChart

Basic Waterfall in Angular

Using ApexCharts with Angular

This Basic Waterfall example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Operating income',
              data: [
                {
                  x: 'Net revenue',
                  y: 8786000,
                },
                {
                  x: 'Cost of sales',
                  y: -2786000,
                },
                {
                  x: 'Gross profit',
                  isSubtotal: true,
                },
                {
                  x: 'Operating expenses',
                  y: -1786000,
                },
                {
                  x: 'Amortisation',
                  y: -453000,
                },
                {
                  x: 'Income from equity',
                  y: 1465000,
                },
                {
                  x: 'Operating income',
                  isTotal: true,
                },
              ],
            },
          ],
          chart: {
            type: 'waterfall',
            height: 380,
          },
          title: {
            text: 'From revenue to operating income',
            align: 'left',
          },
          subtitle: {
            text: 'FY 2025, in thousands of USD',
            align: 'left',
          },
          yaxis: {
            labels: {
              formatter: (val) => {
                return (val / 1000).toFixed(0) + 'k'
              },
            },
          },
          dataLabels: {
            formatter: (val) => {
              return (val / 1000).toFixed(0) + 'k'
            },
          },
          tooltip: {
            y: {
              formatter: (val) => {
                return (val > 0 ? '+' : '') + val.toLocaleString('en-US')
              },
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Basic Waterfall in Vue

Using ApexCharts with Vue

This Basic Waterfall example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="waterfall"
        height="380"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Operating income',
          data: [
            {
              x: 'Net revenue',
              y: 8786000,
            },
            {
              x: 'Cost of sales',
              y: -2786000,
            },
            {
              x: 'Gross profit',
              isSubtotal: true,
            },
            {
              x: 'Operating expenses',
              y: -1786000,
            },
            {
              x: 'Amortisation',
              y: -453000,
            },
            {
              x: 'Income from equity',
              y: 1465000,
            },
            {
              x: 'Operating income',
              isTotal: true,
            },
          ],
        },
      ],
      chartOptions: {
        chart: {
          type: 'waterfall',
          height: 380,
        },
        title: {
          text: 'From revenue to operating income',
          align: 'left',
        },
        subtitle: {
          text: 'FY 2025, in thousands of USD',
          align: 'left',
        },
        yaxis: {
          labels: {
            formatter: function (val) {
              return (val / 1000).toFixed(0) + 'k'
            },
          },
        },
        dataLabels: {
          formatter: function (val) {
            return (val / 1000).toFixed(0) + 'k'
          },
        },
        tooltip: {
          y: {
            formatter: function (val) {
              return (val > 0 ? '+' : '') + val.toLocaleString('en-US')
            },
          },
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
</style>